Index: src/sas/sascalc/dataloader/readers/cansas_constants.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_constants.py	(revision b699768550de9d4b35b087234ec1d2a461922bab)
+++ src/sas/sascalc/dataloader/readers/cansas_constants.py	(revision d398285d1a07fbcba8a3328a6db3de09fb8581df)
@@ -106,5 +106,5 @@
                        "unit" : "x_unit",
                        "attributes" : {"unit" :
-                                       {"variable" : "{0}._xunit = \"{1}\"",
+                                       {"variable" : "{0}.xaxis(\"Q\", \'{1}\')",
                                         "storeas" : "content"
                                        }
@@ -114,5 +114,5 @@
                        "unit" : "y_unit",
                        "attributes" : {"unit" :
-                                       {"variable" : "{0}._yunit = \"{1}\"",
+                                       {"variable" : "{0}.yaxis(\"Intensity\", \'{1}\')",
                                         "storeas" : "content"
                                        }
Index: src/sas/sascalc/dataloader/readers/cansas_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision af09f48ee05aacd17a218896f1cca0cb84a30a5f)
+++ src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision d398285d1a07fbcba8a3328a6db3de09fb8581df)
@@ -12,5 +12,6 @@
 #copyright 2008,2009 University of Tennessee
 #############################################################################
-
+##TODO: Replace 1/A with 1/\AA for Angstorm
+##TODO: Put in x-axis and y-axis information
 import logging
 import numpy
@@ -456,4 +457,8 @@
                     attrib_variable = cansas_attrib.get("variable")
                     if key == 'unit' and unit != '':
+                        if unit == "1/A":
+                            unit = "A^{-1}"
+                        elif unit == "1/cm":
+                            unit = "cm^{-1}"
                         attrib_value = unit
                     else:
Index: src/sas/sascalc/dataloader/readers/cansas_reader_HDF5.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_reader_HDF5.py	(revision ad52d31bb746a70198079b061be06440f3072786)
+++ src/sas/sascalc/dataloader/readers/cansas_reader_HDF5.py	(revision d398285d1a07fbcba8a3328a6db3de09fb8581df)
@@ -109,5 +109,8 @@
             attr_keys = value.attrs.keys()
             attr_values = value.attrs.values()
-            class_name = value.attrs.get(u'NX_class')
+            if value.attrs.get(u'canSAS_class') is not None:
+                class_name = value.attrs.get(u'canSAS_class')
+            else:
+                class_name = value.attrs.get(u'NX_class')
             if class_name is not None:
                 class_prog = re.compile(class_name)
@@ -131,4 +134,5 @@
                 for data_point in data_set:
                     ## Top Level Meta Data
+                    unit = self._get_unit(value)
                     if key == u'definition':
                         self.current_dataset.meta_data['reader'] = data_point
@@ -142,11 +146,10 @@
                     ## I and Q Data
                     elif key == u'I':
-                        i_unit = value.attrs.get(u'unit')
                         if type(self.current_dataset) is Data2D:
                             self.current_dataset.data = np.append(self.current_dataset.data, data_point)
-                            self.current_dataset.zaxis("Intensity (%s)" % (i_unit), i_unit)
+                            self.current_dataset.zaxis("Intensity", unit)
                         else:
                             self.current_dataset.y = np.append(self.current_dataset.y, data_point)
-                            self.current_dataset.yaxis("Intensity (%s)" % (i_unit), i_unit)
+                            self.current_dataset.yaxis("Intensity", unit)
                     elif key == u'Idev':
                         if type(self.current_dataset) is Data2D:
@@ -155,6 +158,5 @@
                             self.current_dataset.dy = np.append(self.current_dataset.dy, data_point)
                     elif key == u'Q':
-                        q_unit = value.attrs.get(u'unit')
-                        self.current_dataset.xaxis("Q (%s)" % (q_unit), q_unit)
+                        self.current_dataset.xaxis("Q", unit)
                         if type(self.current_dataset) is Data2D:
                             self.current_dataset.q = np.append(self.current_dataset.q, data_point)
@@ -162,12 +164,10 @@
                             self.current_dataset.x = np.append(self.current_dataset.x, data_point)
                     elif key == u'Qy':
-                        q_unit = value.attrs.get(u'unit')
-                        self.current_dataset.yaxis("Q (%s)" % (q_unit), q_unit)
+                        self.current_dataset.yaxis("Q_y", unit)
                         self.current_dataset.qy_data = np.append(self.current_dataset.qy_data, data_point)
                     elif key == u'Qydev':
                         self.current_dataset.dqy_data = np.append(self.current_dataset.dqy_data, data_point)
                     elif key == u'Qx':
-                        q_unit = value.attrs.get(u'unit')
-                        self.current_dataset.xaxis("Q (%s)" % (q_unit), q_unit)
+                        self.current_dataset.xaxis("Q_x", unit)
                         self.current_dataset.qx_data = np.append(self.current_dataset.qx_data, data_point)
                     elif key == u'Qxdev':
@@ -191,8 +191,8 @@
                     elif key == u'SDD' and parent == u'SASdetector':
                         self.detector.distance = data_point
-                        self.detector.distance_unit = value.attrs.get(u'unit')
+                        self.detector.distance_unit = unit
                     elif key == u'SSD' and parent == u'SAScollimation':
                         self.collimation.length = data_point
-                        self.collimation.length_unit = value.attrs.get(u'unit')
+                        self.collimation.length_unit = unit
                     elif key == u'name' and parent == u'SAScollimation':
                         self.collimation.name = data_point
@@ -221,5 +221,5 @@
                     elif key == u'wavelength' and parent == u'SASdata':
                         self.source.wavelength = data_point
-                        self.source.wavelength.unit = value.attrs.get(u'unit')
+                        self.source.wavelength.unit = unit
                     elif key == u'radiation' and parent == u'SASsource':
                         self.source.radiation = data_point
@@ -426,2 +426,21 @@
             name = self._create_unique_key(dictionary, name, numb)
         return name
+
+    def _get_unit(self, value):
+        """
+        Find the unit for a particular value within the h5py dictionary
+
+        :param value: attribute dictionary for a particular value set
+        :return:
+        """
+        unit = value.attrs.get(u'units')
+        if unit == None:
+            unit = value.attrs.get(u'unit')
+
+        ## Convert the unit formats
+        if unit == "1/A":
+            unit = "A^{-1}"
+        elif unit == "1/cm":
+            unit = "cm^{-1}"
+
+        return unit
